function Bild(x,y,url,beschriftung,w,h) {
	this.posX = x;
	this.posY = y;
	this.width = w;
	this.height = h;
	this.src = url;
	this.label = replaceUmlaute(beschriftung);

	//Konstruktor-Bereich
	if (typeof x == "undefined") this.posX = 100;
	if (typeof y == "undefined") this.posY = 100;
	if (typeof w == "undefined") this.width="";
	if (typeof h == "undefined") this.height="";
	if (typeof beschriftung == "undefined") this.label="";
	
	this.divId = ++jsLogoGlobalDivIdx;

	this.elementId = this.divId+"img";	
	this.labelId = this.divId+"label";	
	var sResult = '<div id="'+this.divId+'" style="text-align:center; position:absolute;'+'left:' + this.posX + 'px;'+'top:' + this.posY + 'px;">'+'<img id="'+this.elementId+'" src="'+this.src+'" width="'+this.width+'" height="'+this.height+'" alt="'+this.label+'">'+'<div id="'+this.labelId+'" class="picLabel">'+this.label+'<\/div><\/div>';
	document.write(sResult);

	this.setWidth = function(newW) {
		this.width = newW;
		document.getElementById(this.elementId).style.width = newW;
	}
	
	this.getWidth = function() {
		return this.width;
	}

	this.setHeight = function(newH) {
		this.height = newH;
		document.getElementById(this.elementId).style.height = newH;
	}
	
	this.getHeight = function() {
		return this.height;
	}
	
	this.setX = function(newX) {
		this.posX = newX;
		document.getElementById(this.divId).style.left = newX;
	}
	
	this.getX = function() {
		return this.posX;
	}

	this.setY = function(newY) {
		this.posY = newY;
		document.getElementById(this.divId).style.top = newY;
	}
	
	this.getY = function() {
		return this.posY;
	}
	
	this.moveTo = function(x,y) {
		this.x = x;
		this.y = y;
		document.getElementById(this.divId).style.left = x;
		document.getElementById(this.divId).style.top = y;
	}

	this.setUrl = function(newUrl) {
		this.src = newUrl;
		document.getElementById(this.elementId).src = newUrl;
	}
	
	this.getUrl = function() {
		return this.src;
	}

	this.skalieren = this.scale = function(dFactor) {
		if (this.width=="" || this.height=="") {
			alert(unescape("Ein Bild kann nur skaliert werden%2C wenn es vorher einen Wert f%FCr die Breite und die H%F6he bekommen hat."));
		} else {
			if (dFactor<0) dFactor *= (-1);
			this.width *= dFactor;
			this.height *= dFactor;
			document.getElementById(this.elementId).style.width = this.width;
			document.getElementById(this.elementId).style.height = this.height;
		}
	}
	
	this.setText = function(sText) {
		this.label = replaceUmlaute(sText);
		document.getElementById(this.labelId).innerHTML = this.label;
	}

	this.getText = function() {
		return this.label;
	}

	this.getLabel = function() {
		return document.getElementById(this.labelId);
	}

	this.setBorderWidth = function(sWidth) {
		document.getElementById(this.elementId).style.borderWidth = sWidth;
	}
	this.setBorderStyle = function(sStyle) {
		if (sStyle!="dotted"&&sStyle!="dashed"&&sStyle!="solid"&&sStyle!="double"&&sStyle!="groove"&&sStyle!="ridge"&&sStyle!="inset"&&sStyle!="outset") {
			alert("Es sind nur die Stile\n dotted, dashed, solid, double\nund die 3DEffekte\n groove, ridge, inset, outset\n beim Rand erlaubt.");
			document.getElementById(this.elementId).style.borderStyle = "solid";
		} else {
			document.getElementById(this.elementId).style.borderStyle = sStyle;
		}
	}
	this.setBorderColor = function(sColor) {
		document.getElementById(this.elementId).style.borderColor = sColor;
	}
	this.setBorder = function(sBorder) {
		document.getElementById(this.elementId).style.border = sBorder;
	}

	//return this;
}

function Knopf(x,y,beschriftung,calledFunction) {
	if (calledFunction.indexOf('"')!=-1) {
		alert(unescape("Anlegen eines Knopfes%3A%0AEs d%FCrfen keine doppelten Anf%FChrungszeichen benutzt werden."));
		return;
	}
	this.posX = x;
	this.posY = y;
	this.label = replaceUmlaute(beschriftung);
	this.calledFunction = calledFunction;
	//Konstruktor-Bereich
	this.divId = ++jsLogoGlobalDivIdx;

	this.elementId = this.divId+"btn";
	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+'<input type="button" value="' + this.label + '" onClick="'+calledFunction+'">'+'<\/div>';
	document.write(sResult);

	//return this;
}

function ZahlEingabe(x,y,wert) {
	return new Zahleingabe(x,y,wert);
}

function Zahleingabe(x,y,wert) {
	this.x = x;
	this.y = y;
	if (istZahl(wert)) {
		this.value = wert;
	} else {
		this.value = 1;
	}

	this.divId = ++jsLogoGlobalDivIdx;

	this.elementId = this.divId+"numberField";
	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+'<input id="'+this.elementId+'" type="text" value="'+this.value+'" onBlur="this.value = isNumber(this.value)">'+'<\/div>';
	document.write(sResult);	
	
	this.getValue = this.getText = function(){
		//this.value = Number(document.getElementById(this.elementId).value);
		var curWert = document.getElementById(this.elementId).value;
		if (istZahl(curWert)) {
			this.value = document.getElementById(this.elementId).value;
		} else {
			//alert("Keine Zahl. Es wird 1 ausgegeben.");
			this.value = "";
		}
		return this.value;
	}
	
	this.setValue = this.setText = function(iZahl) {
		if (typeof iZahl != "string") iZahl = String(iZahl);
		if (istZahl(iZahl)) {
			this.value = iZahl;
			document.getElementById(this.elementId).value=this.value;
		}
	}
	
	this.add_hervorheben = function(bWert) {
		if (bWert) {
			document.getElementById(this.elementId).onfocus = function(){this.style.color = "#ff0000"};
			document.getElementById(this.elementId).onblur = function(){this.style.color = "#000000"};
		} else {
			document.getElementById(this.elementId).onfocus = function(){};
			document.getElementById(this.elementId).onblur = function(){};		
		}
	}

	//return this;
}

function TextEingabe(x,y,sText) {
	return new Texteingabe(x,y,sText);
}

function Texteingabe(x,y,sText) {
	this.x = x;
	this.y = y;
	this.value = sText;

	this.divId = ++jsLogoGlobalDivIdx;
	
	this.elementId = this.divId+"textField";
	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+'<input id="'+this.elementId+'" type="text" value="'+this.value+'">'+'<\/div>';
	document.write(sResult);	
	
	this.getDivId = function() {
		return this.divId;
	}

	this.getValue = this.getText = function() {
		this.value = document.getElementById(this.elementId).value;
		return this.value;
	}
	
	this.setValue = this.setText = function(iZahl) {
		this.value = iZahl;
		document.getElementById(this.elementId).value=this.value;
	}

	this.add_hervorheben = function(bWert) {
		if (bWert) {
			document.getElementById(this.elementId).onfocus = function(){this.style.color = "#ff0000"};
			document.getElementById(this.elementId).onblur = function(){this.style.color = "#000000"};
		} else {
			document.getElementById(this.elementId).onfocus = function(){};
			document.getElementById(this.elementId).onblur = function(){};		
		}
	}
	
	//return this;
}

function Textfeld(x,y,rows,cols) {
	//Attribute
	this.x = x;
	this.y = y;
	this.rows = rows;
	this.cols = cols;
	this.divId = 0;
	this.elementId = 0;


	//Konstruktor
	this.divId = ++jsLogoGlobalDivIdx;
	this.elementId = this.divId+"textarea";
	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+'<textarea style="border:1px solid #000000;" cols="' + this.cols + '" rows="' + this.rows + '" id="'+this.elementId+'"><\/textarea>'+'<\/div>';
	document.write(sResult);	

	this.setX = function(newX) {
		this.posX = newX;
		document.getElementById(this.divId).style.left = newX;
	}
	
	this.getX = function() {
		return this.posX;
	}

	this.setY = function(newY) {
		this.posY = newY;
		document.getElementById(this.divId).style.top = newY;
	}
	
	this.getY = function() {
		return this.posY;
	}
	
	this.moveTo = function(x,y) {
		this.x = x;
		this.y = y;
		document.getElementById(this.divId).style.left = x;
		document.getElementById(this.divId).style.top = y;
	}

	this.setText = function(sText) {
		document.getElementById(this.elementId).value = unescape(replaceUmlauteTextArea(sText));
	}

	this.getText = function() {
		return document.getElementById(this.elementId).value;
	}

	this.setColor = function(sColor) {
		document.getElementById(this.elementId).style.color = sColor;
	}
	
	this.setCols = function(sCols) {
		document.getElementById(this.elementId).cols = sCols;
	}

	this.setRows = function(sRows) {
		document.getElementById(this.elementId).rows = sRows;
	}
	
	this.setBorderWidth = function(sWidth) {
		document.getElementById(this.elementId).style.borderWidth = sWidth;
	}
	this.setBorderStyle = function(sStyle) {
		if (sStyle!="dotted"&&sStyle!="dashed"&&sStyle!="solid"&&sStyle!="double"&&sStyle!="groove"&&sStyle!="ridge"&&sStyle!="inset"&&sStyle!="outset") {
			alert("Es sind nur die Stile\n dotted, dashed, solid, double\nund die 3DEffekte\n groove, ridge, inset, outset\n beim Rand erlaubt.");
			document.getElementById(this.elementId).style.borderStyle = "solid";
		} else {
			document.getElementById(this.elementId).style.borderStyle = sStyle;
		}
	}
	this.setBorderColor = function(sColor) {
		document.getElementById(this.elementId).style.borderColor = sColor;
	}
	this.setBorder = function(sBorder) {
		document.getElementById(this.elementId).style.border = sBorder;
	}
	
	this.setBackground = function (sColor) {
		document.getElementById(this.elementId).style.backgroundColor = sColor;
	}
	
	this.getTextarea = function() {
		return document.getElementById(this.elementId);
	}
	
	this.add_hervorheben = function(bWert) {
		if (bWert) {
			document.getElementById(this.elementId).onfocus = function(){this.style.color = "#ff0000"};
			document.getElementById(this.elementId).onblur = function(){this.style.color = "#000000"};
		} else {
			document.getElementById(this.elementId).onfocus = function(){};
			document.getElementById(this.elementId).onblur = function(){};		
		}
	}

	//return this;
}

function EingabefensterZahl(sFrage,sVorbelegung) {
	if (isNaN(sVorbelegung)) sVorbelegung=0;
	if (typeof sFrage == "undefined") sFrage="Gib eine Zahl ein.";
	if (sFrage=="") sFrage="Gib eine Zahl ein.";
	if (sVorbelegung=="") sVorbelegung=0;
	var sResult = Number(prompt(unescape(corrAlertCode(sFrage)),sVorbelegung));
	if (isNaN(sResult)) {
		alert("Die Eingabe war keine Zahl.\n Kommazahlen mit Punkt eingeben; also '1.5' statt '1,5' .\nDas Ergebnis ist vorsorglich '1'.");	
		return 1;
	}
	return sResult;
}
function ZahlDialog(sFrage,sVorbelegung) {
	return EingabefensterZahl(sFrage,sVorbelegung);
}

function EingabefensterText(sFrage,sVorbelegung) {
	if (typeof sFrage == "undefined") sFrage="Gib einen Text ein.";
	if (typeof sVorbelegung == "undefined") sVorbelegung="-";
	if (sFrage=="") sFrage="Gib einen Text ein.";
	if (sVorbelegung=="") sVorbelegung="-";
	return prompt(unescape(corrAlertCode(sFrage)),sVorbelegung);
}
function TextDialog(sFrage,sVorbelegung) {
	return EingabefensterText(sFrage,sVorbelegung);
}


function Warnung(sText) {
	if (typeof sText == "undefined") sText=String(sText);
	if (sText == "") sText="- Keine Wert -";
	alert(unescape(corrAlertCode(sText)));
}
function w(sText) {
	Warnung(sText);
}

function Verweis(x,y,sText,sZiel) {
	//Attribute
	this.x = x;
	this.y = y;
	this.divId = 0;
	this.elementId = 0;
	this.name = replaceUmlaute(sText);
	if (checkSonderzeichen(sZiel)) {
		this.link = sZiel;
	} else {
		this.link = "#";
		return this;
	}

	//Konstruktor
	this.divId = ++jsLogoGlobalDivIdx;


	this.elementId = this.divId+"textarea";
	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+'<span id="'+this.elementId+'"><a href="'+this.link+'" target="_blank">'+this.name+'<\/a><\/span>'+'<\/div>';
	document.write(sResult);	

	//return this;
}

function Paragraph(x,y,sText) {
	//Attribute
	this.x = x;
	this.y = y;
	this.divId = 0;
	this.elementId = 0;
	this.inhalt = replaceUmlaute(sText);

	//Konstruktor
	this.divId = ++jsLogoGlobalDivIdx;

	var sResult = '<div id="'+this.divId+'" style="position:absolute;'+'left:' + x + 'px;'+'top:' + y + 'px;">'+this.inhalt+'<\/div>';
	document.write(sResult);	
	
	this.setX = function(newX) {
		this.posX = newX;
		document.getElementById(this.divId).style.left = newX;
	}
	
	this.getX = function() {
		return this.posX;
	}

	this.setY = function(newY) {
		this.posY = newY;
		document.getElementById(this.divId).style.top = newY;
	}
	
	this.getY = function() {
		return this.posY;
	}
	
	this.moveTo = function(x,y) {
		this.x = x;
		this.y = y;
		document.getElementById(this.divId).style.left = x;
		document.getElementById(this.divId).style.top = y;
	}

	this.setText = function(sText) {
		document.getElementById(this.divId).inhalt = sText;
	}

	this.getText = function() {
		return document.getElementById(this.divId).inhalt;
	}

	this.setColor = function(sColor) {
		document.getElementById(this.divId).style.color = sColor;
	}
	
	this.setSize = function(sSize) {
		if (typeof sSize != "string") sSize = String(sSize);
		if (istZahl(sSize)) {
			document.getElementById(this.divId).style.fontSize = sSize+"px";
		} else {
			alert(unescape(sSize+ " ist keine korrekte Angaben f%FCr die Schriftgr%F6%DFe. Es sind nur Angaben wie 8,9,10,... erlaubt."));
		}
	}
	
	this.setFontFamily = function(sFamily) {
		if (typeof sFamily != "string") sFamily = String(sFamily);
		if (sFamily!="sans-serif"&&sFamily!="serif"&&sFamily!="monospace"&&sFamily!="Verdana"&&sFamily!="Arial"&&sFamily!="Times"&&sFamily!="Courier") {
			alert(unescape(sStyle+ " ist keine korrekte Angaben f%FCr den Schriftstil. Es gibt nur sans-serif, serif, monospace, Verdana, Arial, Times, Courier."));
		} else {
		document.getElementById(this.divId).style.fontFamily = sFamily;
		}
	}
	
	this.setFontWeight = function(sWeight) {
		if (typeof sWeight != "string") sWeight = String(sWeight);
		if (sWeight!="bold"&&sWeight!="bolder"&&sWeight!="lighter"&&sWeight!="normal") {
			alert(unescape(sWeight+ " ist keine korrekte Angaben f%FCr den Schriftgewicht. Es gibt nur bold, bolder, lighter, normal."));
		} else {
			document.getElementById(this.divId).style.fontWeight = sWeight;
		}
	}

	this.setFontStyle = function(sStyle) {
		if (typeof sStyle != "string") sStyle = String(sStyle);
		if (sStyle!="italic"&&sStyle!="oblique"&&sStyle!="normal") {
			alert(unescape(sStyle+ " ist keine korrekte Angaben f%FCr den Schriftstil. Es gibt nur >italic<, >oblique< und >normal< ."));
		} else {
			document.getElementById(this.divId).style.fontStyle = (sStyle);		
		}
	}
	
	
	this.setBorderWidth = function(sWidth) {
		if (typeof sWidth != "string") sWidth = String(sWidth);
		if (istZahl(sWidth) || sWidth<1) {
			document.getElementById(this.divId).style.borderWidth = sWidth;
		} else {
			alert(unescape(sWidth+ " ist keine korrekte Angaben f%FCr die Breite eines Pragrafen. Es sind nur Angaben wie 1,2,3,... erlaubt."));
		}
	}

	this.setBorderStyle = function(sWidth) {
		if (typeof sWidth != "string") sWidth = String(sWidth);
		if (sStyle!="dotted"&&sStyle!="dashed"&&sStyle!="solid"&&sStyle!="double"&&sStyle!="groove"&&sStyle!="ridge"&&sStyle!="inset"&&sStyle!="outset") {
			alert("Es sind nur die Stile\n dotted, dashed, solid, double\nund die 3DEffekte\n groove, ridge, inset, outset\n beim Rand erlaubt.");
			document.getElementById(this.divId).style.borderStyle = "solid";
		} else {
			document.getElementById(this.divId).style.borderStyle = sStyle;
		}
	}

	this.setBorderColor = function(sColor) {
		document.getElementById(this.divId).style.borderColor = sColor;
	}

	this.setBorder = function(sBorder) {
		document.getElementById(this.divId).style.border = sBorder;
	}
	
	this.setBackground = function (sColor) {
		document.getElementById(this.divId).style.backgroundColor = sColor;
	}
}

function schreibe(sString) {
	document.write(replaceUmlaute(sString));
}

function schreibeL(sString) {
	document.write(replaceUmlaute(sString)+"<br>");
}


function p(sString) {
	document.write(replaceUmlaute(sString));
}

function pL(sString) {
	document.write(replaceUmlaute(sString)+"<br>");
}

function leerzeile() {
	document.write("<br>");
}


//----------- Ergaenzungen -----------
function replaceUmlaute(curText) {
	if (typeof curText != "number" && typeof curText != "string" ) {
		alert("Sie versuchen Text auszugeben, der kein Text ist sondern: "+typeof curText);
		return "err";
	}
	if (curText == "") return "";
	if (typeof curText == "number") curText = String(curText);
	var result = curText;
	result=result.replace(/\u00fc/g, "&uuml;");
	result=result.replace(/\u00f6/g, "&ouml;");
	result=result.replace(/\u00e4/g, "&auml;");
	result=result.replace(/\u00dc/g, "&Uuml;");
	result=result.replace(/\u00d6/g, "&Ouml;");
	result=result.replace(/\u00c4/g, "&Auml;");
	result=result.replace(/\u00df/g, "&szlig;");
	result=result.replace(//g, "&uuml;");
	result=result.replace(//g, "&ouml;");
	result=result.replace(//g, "&auml;");
	result=result.replace(//g, "&Uuml;");
	result=result.replace(//g, "&Ouml;");
	result=result.replace(//g, "&Auml;");
	result=result.replace(//g, "&szlig;");
	return result;
}

function replaceUmlauteTextArea(curText) {
	if (typeof curText != "number" && typeof curText != "string" ) {
		alert("Sie versuchen Text auszugeben, der kein Text ist sondern: "+typeof curText);
		return "err";
	}
	if (typeof curText == "number") curText = String(curText);
	if (curText == "") {return "";}
	var result = curText;
	result=result.replace(/\u00fc/g, "%FC");//%FC%E4%F6%DC%C4%D6%0A
	result=result.replace(/\u00f6/g, "%F6");
	result=result.replace(/\u00e4/g, "%E4");
	result=result.replace(/\u00dc/g, "%DC");
	result=result.replace(/\u00d6/g, "%D6");
	result=result.replace(/\u00c4/g, "%C4");
	result=result.replace(/\u00df/g, "%DF");
	result=result.replace(//g, "%FC");
	result=result.replace(//g, "%F6");
	result=result.replace(//g, "%E4");
	result=result.replace(//g, "%DC");
	result=result.replace(//g, "%D6");
	result=result.replace(//g, "%C4");
	result=result.replace(//g, "%DF");
	return result;
}

function checkSonderzeichen(curText) {
	if (curText == "" || typeof curText == "undefined") return true;
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	if (curText.search(//)!=-1) {alert(unescape("Hin Verweisen d%FCrfen keine Sonderzeichen %E4%F6%FC%DF auftreten."));return false;};
	return true;
}

function isNumber(curValue) {
	curValue = curValue.replace(/,/g,".");
	if (curValue == "") return 0;
	if (isNaN(Number(curValue))) {
		alert("Es wurde keine Zahl eingegeben.");
		return 0;
	}
	return curValue;
}

function corrAlertCode(s1) {
  if (s1.length>0) {
    var i,j;
	var s2 = s1;
	s2=s2.replace(/\u00fc/g, "%FC");//%FC%E4%F6%DC%C4%D6%0A
	s2=s2.replace(/\u00f6/g, "%F6");
	s2=s2.replace(/\u00e4/g, "%E4");
	s2=s2.replace(/\u00dc/g, "%DC");
	s2=s2.replace(/\u00d6/g, "%D6");
	s2=s2.replace(/\u00c4/g, "%C4");
	s2=s2.replace(/\u00df/g, "%DF");
	s2=s2.replace(//g, "%FC");
	s2=s2.replace(//g, "%F6");
	s2=s2.replace(//g, "%E4");
	s2=s2.replace(//g, "%DC");
	s2=s2.replace(//g, "%D6");
	s2=s2.replace(//g, "%C4");
	s2=s2.replace(//g, "%DF");

    //Zeilenumbrueche verkuerzen
    var a1=s2.split("%0D");
    s2="";
    for (i=0;i<a1.length;i++) {
      s1=a1[i];
      if (s1.substring(0,3)=="%0A") { s1=s1.substring(3,s1.length); }
      s2+="%0D"+s1;
    }
    s2=s2.substring(3,s2.length);
    //Leerzeichen ohne Code
    var a2=s2.split("%20");
    s2="";
    for (i=0;i<a2.length;i++) { s1=a2[i]; s2+=" "+s1;}
    s2=s2.substring(1,s2.length);
	return s2;
  }
  return "";
}

function replaceMathTerms(curText) {
	if (curText == "") return "";
	if (typeof curText != "string") curText = String(curText);
	var result = curText;
	result=result.replace(/sin/g, "Math.sin");
	result=result.replace(/cos/g, "Math.cos");
	result=result.replace(/tan/g, "Math.tan");
	result=result.replace(/asin/g, "Math.asin");
	result=result.replace(/acos/g, "Math.acos");
	result=result.replace(/atan/g, "Math.atan");
	result=result.replace(/log/g, "Math.log");
	result=result.replace(/ln/g, "Math.ln");
	result=result.replace(/exp/g, "Math.exp");
	result=result.replace(/sqrt/g, "Math.sqrt");
	result=result.replace(/sqr/g, "Math.sqr");
	result=result.replace(/pow/g, "Math.pow");
	result=result.replace(/Math.Math/g, "Math");
	return result;
}

function removeMathPrefix(curText) {
	if (curText == "") return "";
	if (typeof curText != "string") curText = String(curText);
	var result = curText;
	result=result.replace(/Math./g, "");
	return result;
}